# TODO: change directories to your development environment!

ESPIDF=~/esp/esp-idf-4-2-2
LV_MICROPYTHON=~/src/lv_micropython
BOARD=M5CORE2
#BOARD=GENERIC_SPIRAM
PORT=/dev/ttyUSB0
ORIGINAL_DIR=$(pwd)
TESTAPP_DIR=$ORIGINAL_DIR/testapp


#----------- Prerequirements -----------
function install_prereqs(){
echo Install 'ampy'
sudo pip3 install adafruit-ampy

echo Install 'picocom'
sudo apt -y install picocom
}


#----------- Build firmware -----------
function build_firmware(){
# Use ESP32 build context
source $ESPIDF/export.sh

cd $LV_MICROPYTHON

# Build mpy-cross
make -C mpy-cross

cd ports/esp32

# Clear build folder
make clean BOARD=$BOARD

# Build ESP32 port
make submodules
make BOARD=$BOARD DEBUG=1

# Erase device FLASH
make erase BOARD=$BOARD

# Deploy firmware
make deploy BOARD=$BOARD

# Wait for reset time
sleep 5

cd $ORIGINAL_DIR
}


#----------- Upload test app -----------
function upload_test_app(){
cd $TESTAPP_DIR

echo Format device FS
ampy --port $PORT run "$TESTAPP_DIR/format-device-fs.py"

echo Upload test app
ampy --port $PORT put "$TESTAPP_DIR/main.py" "/main.py"
ampy --port $PORT put "$TESTAPP_DIR/test.png" "/test.png"

echo Device files
ampy --port $PORT ls

echo Reset device
ampy --port $PORT reset

# Wait for reset time
sleep 5

cd $ORIGINAL_DIR
}


#----------- Monitor test app -----------
function monitor(){
echo ------------------------- EXIT: CTRL-A CTRL-X -------------------------
echo !!!!!!!!!!!!!!!!!!!!! Reset device manually again! !!!!!!!!!!!!!!!!!!!!
fuser -k $PORT
picocom $PORT -b 115200
fuser -k $PORT
}


#---------------------------------------
install_prereqs
build_firmware
upload_test_app
monitor
