# This app works with unix port, and ESP32 port (M5CORE2 and GENERIC_SPIRAM boards)

#----------------------
# Init LVGL
import lvgl as lv
lv.init()



try:
    # Try first M5Core2 device
    from m5core2_power import Power
    power = Power()

    from ili9XXX import ili9341
    lcd = ili9341(mosi=23, miso=38, clk=18, dc=15, cs=5, invert=True, rot=0x10, width=320, height=240, rst=-1, power=-1, backlight=-1)

    from ft6x36 import ft6x36
    touch = ft6x36(width=320, height=280)
except:
    from imagetools import get_png_info, open_png
    import display_driver_utils
    driver = display_driver_utils.driver()

#----------------------
# Main app

# Load PNG
from imagetools import get_png_info, open_png

decoder = lv.img.decoder_create()
decoder.info_cb = get_png_info
decoder.open_cb = open_png

with open('test.png', 'rb') as f:
  png_data = f.read()

png_img_dsc = lv.img_dsc_t({
    'data_size': len(png_data),
    'data': png_data 
})

# Show PNG file on screen:
scr = lv.scr_act()
img = lv.img(scr)
img.set_src(png_img_dsc)
img.center()
